--- wine/include/commctrl.h	Fri Feb 22 22:11:51 2002
+++ mywine/include/commctrl.h	Thu Feb 28 23:29:45 2002
@@ -1013,6 +1013,17 @@
 #define TB_GETCOLORSCHEME        CCM_GETCOLORSCHEME
 #define TB_SETUNICODEFORMAT      CCM_SETUNICODEFORMAT
 #define TB_GETUNICODEFORMAT      CCM_GETUNICODEFORMAT
+#define TB_GETSTRINGW            (WM_USER+91)
+#define TB_GETSTRINGA            (WM_USER+92)
+#define TB_GETSTRING  WINELIB_NAME_AW(TB_GETSTRING)
+
+/* undocumented messages in Toolbar */
+#define TB_UNKWN45D              (WM_USER+93)
+#define TB_UNKWN45E              (WM_USER+94)
+#define TB_UNKWN460              (WM_USER+96)
+#define TB_UNKWN463              (WM_USER+99)
+#define TB_UNKWN464              (WM_USER+100)
+
 
 #define TBN_FIRST               (0U-700U)
 #define TBN_LAST                (0U-720U)
--- wine/windows/spy.c	Tue Feb 26 21:45:02 2002
+++ mywine/windows/spy.c	Thu Feb 28 23:56:07 2002
@@ -1387,6 +1387,13 @@
           USM(TB_SETINSERTMARKCOLOR    ,0),
           USM(TB_GETINSERTMARKCOLOR    ,0),
           USM(TB_MAPACCELERATORW       ,0),
+	  USM(TB_GETSTRINGW            ,0),
+	  USM(TB_GETSTRINGA            ,0),
+	  USM(TB_UNKWN45D              ,8),
+	  USM(TB_UNKWN45E              ,0),
+	  USM(TB_UNKWN460              ,0),
+	  USM(TB_UNKWN463              ,8),
+	  USM(TB_UNKWN464              ,0),
           {0,0,0} };
 
 static const USER_MSG comboex_array[] = {
--- wine/dlls/comctl32/toolbar.c	Tue Feb 26 21:45:00 2002
+++ mywine/dlls/comctl32/toolbar.c	Fri Mar  1 21:32:49 2002
@@ -4027,6 +4041,40 @@
     return iOldVersion;
 }
 
+static LRESULT
+TOOLBAR_Unkwn463 (HWND hwnd, WPARAM wParam, LPARAM lParam)
+{
+    TOOLBAR_INFO *infoPtr = TOOLBAR_GetInfoPtr (hwnd);
+    LPSIZE lpsize = (LPSIZE)lParam;
+
+    if (lpsize == NULL)
+	return FALSE;
+
+    /*
+     * Testing shows the following:
+     *   wParam    =0 adjust cx value
+     *             =1 adjust cy value
+     *   lParam    pointer to SIZE structure
+     *
+     */
+    TRACE("[0463] wParam %d, lParam 0x%08lx -> 0x%08lx 0x%08lx\n",
+	  wParam, lParam, lpsize->cx, lpsize->cy);
+    if (wParam == 0) {
+	lpsize->cx = infoPtr->rcBound.right - infoPtr->rcBound.left;
+    }
+    else if (wParam == 1) {
+	lpsize->cy = infoPtr->rcBound.bottom - infoPtr->rcBound.top;
+    }
+    else {
+	ERR("Unknown wParam %d for Toolbar message [0463]. Please report\n",
+	    wParam);
+	return 0;
+    }
+    TRACE("[0463] set to -> 0x%08lx 0x%08lx\n",
+	  lpsize->cx, lpsize->cy);
+    return 1;
+}
+
 
 static LRESULT
 TOOLBAR_Create (HWND hwnd, WPARAM wParam, LPARAM lParam)
@@ -5170,6 +5218,9 @@
 
 	case TB_SETUNICODEFORMAT:
 	    return TOOLBAR_SetUnicodeFormat (hwnd, wParam, lParam);
+
+	case TB_UNKWN463:
+	    return TOOLBAR_Unkwn463 (hwnd, wParam, lParam);
 
 	case CCM_SETVERSION:
 	    return TOOLBAR_SetVersion (hwnd, (INT)wParam);
